#Importe

from m5stack import *
from m5ui import *
from uiflow import *
import wifiCfg
from m5mqtt import M5mqtt
from m5stack import touch
import time
from numbers import Number

#Diverse Variablen

Screennumber = None
Screen1Pos = None
Screen2Pos = None
x = None
varCase = None
y = None
COOR = None
varTouchx = None
xDis = None
varTouchY = None
yDis = None
j = None


#Aufbau aller Objekte die ich für Bildschirmseite 1 und 2 bneötige

setScreenColor(15)
label14 = M5TextBox(25, 469, "Aufwecken (5sek)", lcd.FONT_DejaVu40, 0, rotate=0)
triangle0 = M5Triangle(426, 456, 426, 516, 498, 486, 0, 0)
label0 = M5TextBox(47, 14, "Beschattung Schalten", lcd.FONT_DejaVu40, 0, rotate=0)
label1 = M5TextBox(4, 337, "Raff_Links", lcd.FONT_DejaVu24, 0, rotate=0)
rectangle15 = M5Rect(465, 500, 65, 65, 12, 0)
label2 = M5TextBox(4, 427, "Raff_Mitte", lcd.FONT_DejaVu24, 0, rotate=0)
rectangle16 = M5Rect(390, 500, 65, 65, 12, 0)
rectangle17 = M5Rect(315, 500, 65, 65, 12, 0)
label3 = M5TextBox(4, 520, "Raff_Rechts", lcd.FONT_DejaVu24, 0, rotate=0)
rectangle18 = M5Rect(240, 500, 65, 65, 12, 0)
rectangle19 = M5Rect(165, 500, 65, 65, 12, 0)
label4 = M5TextBox(4, 607, "Esszimmer", lcd.FONT_DejaVu24, 0, rotate=0)
rectangle20 = M5Rect(315, 590, 65, 65, 12, 0)
rectangle21 = M5Rect(240, 590, 65, 65, 12, 0)
label5 = M5TextBox(4, 697, "Kueche", lcd.FONT_DejaVu24, 0, rotate=0)
rectangle22 = M5Rect(165, 590, 65, 65, 12, 0)
rectangle23 = M5Rect(315, 680, 65, 65, 12, 0)
rectangle24 = M5Rect(240, 680, 65, 65, 12, 0)
label6 = M5TextBox(4, 789, "Flur", lcd.FONT_DejaVu24, 0, rotate=0)
rectangle25 = M5Rect(165, 680, 65, 65, 12, 0)
rectangle26 = M5Rect(315, 770, 65, 65, 12, 0)
label7 = M5TextBox(4, 876, "Markise", lcd.FONT_DejaVu24, 0, rotate=0)
rectangle27 = M5Rect(240, 770, 65, 65, 12, 0)
rectangle28 = M5Rect(165, 770, 65, 65, 12, 0)
label8 = M5TextBox(190, 208, "AUF", lcd.FONT_DejaVu24, 0, rotate=270)
rectangle29 = M5Rect(315, 860, 65, 65, 12, 0)
rectangle30 = M5Rect(240, 860, 65, 65, 12, 0)
label9 = M5TextBox(264, 208, "ZU", lcd.FONT_DejaVu24, 0, rotate=270)
rectangle31 = M5Rect(165, 860, 65, 65, 12, 0)
label10 = M5TextBox(344, 208, "STOPP", lcd.FONT_DejaVu24, 0, rotate=270)
label13 = M5TextBox(4, 250, "Raff_Oben", lcd.FONT_DejaVu24, 0, rotate=0)
label11 = M5TextBox(416, 208, "Schritt_H", lcd.FONT_DejaVu24, 0, rotate=270)
label12 = M5TextBox(487, 208, "Schritt_R", lcd.FONT_DejaVu24, 0, rotate=270)
rectangle0 = M5Rect(465, 230, 65, 65, 12, 0)
rectangle1 = M5Rect(390, 230, 65, 65, 12, 0)
rectangle2 = M5Rect(315, 230, 65, 65, 12, 0)
rectangle3 = M5Rect(240, 230, 65, 65, 12, 0)
rectangle4 = M5Rect(165, 230, 65, 65, 12, 0)
rectangle5 = M5Rect(465, 320, 65, 65, 12, 0)
rectangle6 = M5Rect(390, 320, 65, 65, 12, 0)
rectangle7 = M5Rect(315, 320, 65, 65, 12, 0)
rectangle8 = M5Rect(240, 320, 65, 65, 12, 0)
rectangle9 = M5Rect(165, 320, 65, 65, 12, 0)
label27 = M5TextBox(12, 65, "BAT Voltage [mV]:", lcd.FONT_DejaVu24, 0, rotate=0)
rectangle10 = M5Rect(465, 410, 65, 65, 12, 0)
rectangle11 = M5Rect(390, 410, 65, 65, 12, 0)
label28 = M5TextBox(250, 65, "label28", lcd.FONT_DejaVu24, 0, rotate=0)
rectangle12 = M5Rect(315, 410, 65, 65, 12, 0)
line0 = M5Line(M5Line.PLINE, 0, 55, 540, 55, 0)
rectangle13 = M5Rect(240, 410, 65, 65, 12, 0)
rectangle14 = M5Rect(165, 410, 65, 65, 12, 0)




# FUnktion zum Aufbau von Bildschirmseite 1: bei mir Beschattungen
def Screen1Show():
  global Screennumber, Screen1Pos, Screen2Pos, x, varCase, y, COOR, varTouchx, xDis, varTouchY, yDis, j
  label14.hide()
  triangle0.hide()
  label0.show()
  label0.setText('Beschattung Schalten')
  label1.show()
  label1.setText('Raff_Links')
  label2.show()
  label2.setText('Raff_Mitte')
  label3.show()
  label3.setText('Raff_Rechts')
  label4.show()
  label4.setText('Esszimmer')
  label5.show()
  label5.setText('Kueche')
  label6.show()
  label6.setText('Flur')
  label7.show()
  label7.setText('Markise')
  label8.show()
  label8.setText('Auf')
  label9.show()
  label9.setText('Zu')
  label10.show()
  label10.setText('Stopp')
  label11.show()
  label11.setText('Schritt_H')
  label12.show()
  label12.setText('Schritt_R')
  label13.show()
  label13.setText('Raff_Oben')
  rectangle0.show()
  rectangle1.show()
  rectangle2.show()
  rectangle3.show()
  rectangle4.show()
  rectangle5.show()
  rectangle6.show()
  rectangle7.show()
  rectangle8.show()
  rectangle9.show()
  rectangle10.show()
  rectangle11.show()
  rectangle12.show()
  rectangle13.show()
  rectangle14.show()
  rectangle15.show()
  rectangle16.show()
  rectangle17.show()
  rectangle18.show()
  rectangle19.show()
  rectangle20.show()
  rectangle21.show()
  rectangle22.show()
  rectangle23.show()
  rectangle24.show()
  rectangle25.show()
  rectangle26.show()
  rectangle27.show()
  rectangle28.show()
  rectangle29.show()
  rectangle30.show()
  rectangle31.show()
  label28.setText(str(bat.voltage()))
  lcd.show()
  wait_ms(500)

# Funktion um gesamten Bildschirm auszublenden
def ScreenHide():
  global Screennumber, Screen1Pos, Screen2Pos, x, varCase, y, COOR, varTouchx, xDis, varTouchY, yDis, j
  label0.hide()
  label1.hide()
  label2.hide()
  label3.hide()
  label4.hide()
  label5.hide()
  label6.hide()
  label7.hide()
  label8.hide()
  label9.hide()
  label10.hide()
  label11.hide()
  label12.hide()
  label13.hide()
  rectangle0.hide()
  rectangle1.hide()
  rectangle2.hide()
  rectangle3.hide()
  rectangle4.hide()
  rectangle5.hide()
  rectangle6.hide()
  rectangle7.hide()
  rectangle8.hide()
  rectangle9.hide()
  rectangle10.hide()
  rectangle11.hide()
  rectangle12.hide()
  rectangle13.hide()
  rectangle14.hide()
  rectangle15.hide()
  rectangle16.hide()
  rectangle17.hide()
  rectangle18.hide()
  rectangle19.hide()
  rectangle20.hide()
  rectangle21.hide()
  rectangle22.hide()
  rectangle23.hide()
  rectangle24.hide()
  rectangle25.hide()
  rectangle26.hide()
  rectangle27.hide()
  rectangle28.hide()
  rectangle29.hide()
  rectangle30.hide()
  rectangle31.hide()
  label14.show()
  triangle0.show()
  label28.setText(str(bat.voltage()))
  lcd.show()
  wait_ms(500)
  power.epd_power_off()
  power.ext_power_off()
  power.main_power_off()

# Diverse Koordinaten zur Positioniereung von Elementen auf Bidschirmseite 1
def Screen1Koordinaten():
  global Screennumber, Screen1Pos, Screen2Pos, x, varCase, y, COOR, varTouchx, xDis, varTouchY, yDis, j
  Screen1Pos = [[165, 230], [240, 230], [315, 230], [390, 230], [465, 230], [165, 320], [240, 320], [315, 320], [390, 320], [465, 320], [165, 410], [240, 410], [315, 410], [390, 410], [465, 410], [165, 500], [240, 500], [315, 500], [390, 500], [465, 500], [165, 590], [240, 590], [315, 590], [165, 680], [240, 680], [315, 680], [165, 770], [240, 770], [315, 770], [165, 860], [240, 860], [315, 860]]

# FUnktion zum Aufbau von Bildschirmseite 2: bei mir Beleuchtungen
def Screen2Show():
  global Screennumber, Screen1Pos, Screen2Pos, x, varCase, y, COOR, varTouchx, xDis, varTouchY, yDis, j
  label14.hide()
  triangle0.hide()
  label0.show()
  label0.setText('Lichter Schalten')
  label1.show()
  label1.setText('Wohn Steh')
  label2.show()
  label2.setText('Wohn Lese')
  label3.show()
  label3.setText('Wohn Decke')
  label4.show()
  label4.setText('Ess Decke')
  label5.show()
  label5.setText('Ess Schrank')
  label6.show()
  label6.setText('Kueche')
  label7.show()
  label7.setText('Flur')
  label8.show()
  label8.setText('An')
  label9.show()
  label9.setText('Aus')
  label10.hide()
  label11.hide()
  label12.hide()
  label13.setText('Wohn Schr.')
  label13.show()
  rectangle0.hide()
  rectangle1.hide()
  rectangle2.hide()
  rectangle3.show()
  rectangle4.show()
  rectangle5.hide()
  rectangle6.hide()
  rectangle7.hide()
  rectangle8.show()
  rectangle9.show()
  rectangle10.hide()
  rectangle11.hide()
  rectangle12.hide()
  rectangle13.show()
  rectangle14.show()
  rectangle15.hide()
  rectangle16.hide()
  rectangle17.hide()
  rectangle18.show()
  rectangle19.show()
  rectangle20.hide()
  rectangle21.show()
  rectangle22.show()
  rectangle23.hide()
  rectangle24.show()
  rectangle25.show()
  rectangle26.hide()
  rectangle27.show()
  rectangle28.show()
  rectangle29.hide()
  rectangle30.show()
  rectangle31.show()
  label28.setText(str(bat.voltage()))
  lcd.show()
  wait_ms(500)

# Diverse Koordinaten zur Positioniereung von Elementen auf Bidschirmseite 2
def Screen2Koordinaten():
  global Screennumber, Screen1Pos, Screen2Pos, x, varCase, y, COOR, varTouchx, xDis, varTouchY, yDis, j
  Screen2Pos = [[165, 230], [240, 230], [165, 320], [240, 320], [165, 410], [240, 410], [165, 500], [240, 500], [165, 590], [240, 590], [165, 680], [240, 680], [165, 770], [240, 770], [165, 860], [240, 860]]

# Das was ich auf dem Bildschirm 1 oder 2 gedrückt habe wird per MQTT an meine SMart-HOme Zentrale gesendet. Dort wird der Wert dann verabreitet und die entsprechenden Elemente geschaltet.... Ich nutze IOBroker auf RPI4
def MQTT():
  global Screennumber, Screen1Pos, Screen2Pos, x, varCase, y, COOR, varTouchx, xDis, varTouchY, yDis, j
  if Screennumber==0:
    m5mqtt.publish(str('Screen1Button'), str(varCase), 0)
    TouchAreaMarking()
    m5mqtt.publish(str('Screen1Button'), str(varCase), 0)
  elif Screennumber==1:
    m5mqtt.publish(str('Screen2Button'), str(varCase), 0)
    TouchAreaMarking()
    m5mqtt.publish(str('Screen2Button'), str(varCase), 0)
  else:
    pass

# Funktion zum hervorheben des jeweils gedrückten buttons: Highlighten
def TouchAreaMarking():
  global Screennumber, Screen1Pos, Screen2Pos, x, varCase, y, COOR, varTouchx, xDis, varTouchY, yDis, j
  x = COOR[0]
  y = COOR[1]
  lcd.partial_show(x, y, 65, 65)
  lcd.partial_show(40, 100, 80, 80)
  wait_ms(500)
  varCase = 0

# Funktion zum erkennen wo ich gedrückt habe
def ScreenGetTouch():
  global Screennumber, Screen1Pos, Screen2Pos, x, varCase, y, COOR, varTouchx, xDis, varTouchY, yDis, j
  varCase = 0
  if touch.status():
    varTouchx = touch.read()[0]
    varTouchY = touch.read()[1]
    if Screennumber==0:
      for j in range(1, 33):
        COOR = Screen1Pos[int(j - 1)]
        GetTouchArea()
    elif Screennumber==1:
      for j in range(1, 17):
        COOR = Screen2Pos[int(j - 1)]
        GetTouchArea()
    else:
      pass
    wait_ms(150)

# Wertet aus welcher Knopf es ist den ich gerückt habe und startet die MQTT Funktion
def GetTouchArea():
  global Screennumber, Screen1Pos, Screen2Pos, x, varCase, y, COOR, varTouchx, xDis, varTouchY, yDis, j
  x = COOR[0]
  y = COOR[1]
  xDis = x + 65
  yDis = y + 65
  if varTouchx >= x and varTouchx <= xDis and varTouchY >= y and varTouchY <= yDis:
    varCase = j
    MQTT()

# Funktion für den seitlichen Schalter Bewegung nach unten am M5 um zwischen den Bildschrimseiten zu wechseln
def buttonDOWN_wasPressed():
  global Screennumber, Screen1Pos, Screen2Pos, x, varCase, y, COOR, varTouchx, xDis, varTouchY, yDis, j
  Screennumber = (Screennumber if isinstance(Screennumber, Number) else 0) + 1
  if Screennumber > 1:
    Screennumber = 0
  if Screennumber==0:
    Screen1Show()
  elif Screennumber==1:
    Screen2Show()
  else:
    pass
  pass

# wie so eine art Interupt welcher dann die Funktionen für den Bildschirmwechsel aufruft
btnDOWN.wasPressed(buttonDOWN_wasPressed)

# Funktion für den seitlichen Schalter Bewegung nach oben am M5 um zwischen den Bildschrimseiten zu wechseln
def buttonUP_wasPressed():
  global Screennumber, Screen1Pos, Screen2Pos, x, varCase, y, COOR, varTouchx, xDis, varTouchY, yDis, j
  Screennumber = (Screennumber if isinstance(Screennumber, Number) else 0) + -1
  if Screennumber < 0:
    Screennumber = 1
  if Screennumber==0:
    Screen1Show()
  elif Screennumber==1:
    Screen2Show()
  else:
    pass
  pass

# wie so eine art Interupt welcher dann die Funktionen für den Bildschirmwechsel aufruft
btnUP.wasPressed(buttonUP_wasPressed)

# Funktion für den seitlichen Schalter nach innen drücken  am M5 um den M5 in den Ruhemodus zu bringen

def buttonMID_pressFor():
  global Screennumber, Screen1Pos, Screen2Pos, x, varCase, y, COOR, varTouchx, xDis, varTouchY, yDis, j
  ScreenHide()
  pass
btnMID.pressFor(0.8, buttonMID_pressFor)

def buttonMID_wasPressed():
  global Screennumber, Screen1Pos, Screen2Pos, x, varCase, y, COOR, varTouchx, xDis, varTouchY, yDis, j
  label28.setText(str(bat.voltage()))
  lcd.show()
  pass
btnMID.wasPressed(buttonMID_wasPressed)

#WLAN Konfig
wifiCfg.doConnect('FRITZXXXXX', 'ABCDEXXXXXX')
#MQTT Konfig für den Broker
m5mqtt = M5mqtt('M5Paper', '192.XXX.XXX.XX', 1111, 'USER', 'PASSWORD', 300)

m5mqtt.start()
label28.setText(str(bat.voltage()))
Screennumber = 0
Screen1Koordinaten()
Screen2Koordinaten()
Screen1Show()
while True:
  ScreenGetTouch()
  wait_ms(2)
